package ink.wgink.gateway.filter.wg;

import org.springframework.context.annotation.Configuration;
import org.springframework.web.server.ServerWebExchange;
import org.springframework.web.server.WebFilter;
import org.springframework.web.server.WebFilterChain;
import reactor.core.publisher.Mono;

/**
 * When you feel like quitting. Think about why you started
 * 当你想要放弃的时候，想想当初你为何开始
 *
 * @ClassName: WebFluxConfig
 * @Description:
 * @Author: wanggeng
 * @Date: 2021/4/14 2:42 下午
 * @Version: 1.0
 */
@Configuration
public class WebFluxFilter implements WebFilter {

    public static final String SESSION_USER = "SESSION_USER";

    @Override
    public Mono<Void> filter(ServerWebExchange serverWebExchange, WebFilterChain webFilterChain) {
        serverWebExchange.getSession().filter(webSession -> webSession.getAttributes().get(SESSION_USER) == null).then();
        serverWebExchange.getRequest().mutate().path("").build();
        return webFilterChain.filter(serverWebExchange);
    }

}
